
/**
 * @addtogroup ftp
 * @{
 * */

/**
 * @file ftp_constants.h
 * @brief Definitions for FTP. See RFC-765.
 *
 * @author Copyright (c) 1985, 1989 Regents of the University of California.All rights reserved.
 *
 * @note From: @(#)ftp.c  5.38 (Berkeley) 4/22/91
 *
 * */
#ifndef _FTP_CONSTANTS_H
#  define _FTP_CONSTANTS_H

/// Definitions for FTP; see RFC-765.

/// Reply codes.

#  define FTP_PRELIM          1 ///< positive preliminary
#  define FTP_COMPLETE        2 ///< positive completion
#  define FTP_CONTINUE        3 ///< positive intermediate
#  define FTP_TRANSIENT       4 ///< transient negative completion
#  define FTP_ERROR           5 ///< permanent negative completion
#  define FTP_FILE_ERROR      6 ///< permanent negative file error

/// Type codes

#  define TYPE_A          1     ///< ASCII
#  define TYPE_E          2     ///< EBCDIC
#  define TYPE_I          3     ///< image
#  define TYPE_L          4     ///< local byte size

#endif

/**
 * @}
 * */
