
/**
 * @addtogroup ftp
 * @{
 * */

/**
 * @file telnet_constants.h 
 * @brief Declarations of Telnet constants
 *
 * @author Copyright (c) 1985, 1989 Regents of the University of California.All rights reserved.
 *
 * @note From: @(#)ftp.c  5.38 (Berkeley) 4/22/91
 *
 * */

#ifndef _TELNET_CONSTANTS_H
#  define _TELNET_CONSTANTS_H 1

/// Definitions for the TELNET protocol.
#  define IAC     255           ///< Interpret as command:
#  define DONT    254           ///< You are not to use option
#  define DO      253           ///< Please, you use option
#  define WONT    252           ///< I won't use option
#  define WILL    251           ///< I will use option
#  define SB      250           ///< Interpret as subnegotiation
#  define GA      249           ///< You may reverse the line
#  define EL      248           ///< Erase the current line
#  define EC      247           ///< Erase the current character
#  define AYT     246           ///< Are you there
#  define AO      245           ///< Abort output--but let prog finish
#  define IP      244           ///< Interrupt process--permanently
#  define BREAK   243           ///< Break
#  define DM      242           ///< Data mark--for connect. cleaning
#  define NOP     241           ///< Nop
#  define SE      240           ///< End sub negotiation
#  define EOR     239           ///< End of record (transparent mode)
#  define ABORT   238           ///< Abort process
#  define SUSP    237           ///< Suspend process
#  define xEOF    236           ///< End of file: EOF is already used...

#  define SYNCH   242           ///< For telfunc calls

#endif

/**
 * @}
 * */
