/* ANSI C standard library function strncpy.  */

/*
 * Copyright (c) 2001,2003 by Tensilica Inc.  ALL RIGHTS RESERVED.
 * These coded instructions, statements, and computer programs are the
 * copyrighted works and confidential proprietary information of Tensilica Inc.
 * They may not be modified, copied, reproduced, distributed, or disclosed to
 * third parties in any manner, medium, or form, in whole or in part, without
 * the prior written consent of Tensilica Inc.
 */

#include <xtensa/coreasm.h>
/* change by Hareesh for T1050.5 XCC port */
#if 1
#define MIN_ESA  0
#endif
/* end of change by Hareesh */

#if XCHAL_HAVE_BE
#define	MASK0 0xff000000
#define	MASK1 0x00ff0000
#define	MASK2 0x0000ff00
#define	MASK3 0x000000ff
#else
#define	MASK0 0x000000ff
#define	MASK1 0x0000ff00
#define	MASK2 0x00ff0000
#define	MASK3 0xff000000
#endif

# Register use
#   a0/ return address
#   a1/ stack pointer
#   a2/ return value
#   a3/ src
#   a4/ n
#   a11/ mask0
#   a5/ mask1
#   a6/ mask2
#   a7/ mask3
#   a8/ tmp
#   a9/ tmp
#   a10/ dst


	.text
	.align	4
	.global	strncpy
	.type	strncpy,@function
strncpy:
#if !XCHAL_HAVE_WINDOWED || __XTENSA_CALL0_ABI__
	addi a1, a1, -16
	s32i a10, a1, 8
#else
	entry a1, 16+MIN_ESA
#endif
	# a2/ dst, a3/ src
	mov	a10, a2		# leave dst in return value register
	beqz    a4, .Lret       # if n is zero
	movi	a11, MASK0	# mask for byte 0
	movi	a5, MASK1	# mask for byte 1
	movi	a6, MASK2	# mask for byte 2
	movi	a7, MASK3	# mask for byte 3
	bbsi.l	a3, 0, .Lsrc1mod2 # if only  8-bit aligned
	bbsi.l	a3, 1, .Lsrc2mod4 # if only 16-bit aligned
.Lsrcaligned:	# return here when src is word-aligned
	movi	a8, 3
	bnone	a10, a8, .Laligned
	j	.Ldstunaligned

.Lsrc1mod2:	# src address is odd
	l8ui	a8, a3, 0	# get byte 0
	addi	a3, a3, 1	# advance src pointer
	s8i	a8, a10, 0	# store byte 0
	addi	a4, a4, -1	# decrement n
	beqz    a4, .Lret       # if n is zero
	addi	a10, a10, 1	# advance dst pointer
	beqz	a8, .Lfill	# if byte 0 is zero
	bbci.l	a3, 1, .Lsrcaligned # if src is now word-aligned

.Lsrc2mod4:	# src address is 2 mod 4
	l8ui	a8, a3, 0	# get byte 0
	addi	a4, a4, -1	# decrement n
	s8i	a8, a10, 0	# store byte 0
	beqz    a4, .Lret       # if n is zero
	addi	a10, a10, 1	# advance dst pointer
	beqz	a8, .Lfill	# if byte 0 is zero
	l8ui	a8, a3, 1	# get byte 0
	addi	a3, a3, 2	# advance src pointer
	s8i	a8, a10, 0	# store byte 0
	addi	a4, a4, -1	# decrement n
	beqz    a4, .Lret       # if n is zero
	addi	a10, a10, 1	# advance dst pointer
	bnez	a8, .Lsrcaligned
.Lfill:		# fill the dst with zeros, n is at least 1
	movi	a9, 0
	bbsi.l	a10, 0, .Ldst1mod2 # if only  8-bit aligned
	bbsi.l	a10, 1, .Ldst2mod4 # if only 16-bit aligned
.Lfillaligned:	# the dst address is 4 byte aligned
	blti	a4, 4, .Lfillcleanup
#if XCHAL_HAVE_LOOPS
	srai	a8, a4, 2
	loop	a8, .Lfillmain
	s32i	a9, a10, 0
	addi	a10, a10, 4
.Lfillmain:
	slli	a8, a8, 2
	sub	a4, a4, a8
#else 
	# no loops
.Lfillmain:
	s32i	a9, a10, 0
	addi	a10, a10, 4
	addi	a4, a4, -4
	bgei    a4, 4, .Lfillmain 
#endif

	beqz	a4, .Lfillcleanupret
.Lfillcleanup:
	s8i	a9, a10, 0	# store byte 0
	addi	a4, a4, -1	# decrement n
	addi	a10, a10, 1
	bnez    a4, .Lfillcleanup 
.Lfillcleanupret:
#if !XCHAL_HAVE_WINDOWED || __XTENSA_CALL0_ABI__
	l32i a10, a1, 8
	addi a1, a1, 16
	ret
#else
	retw
#endif
	
.Ldst1mod2:	# dst address is odd
	s8i	a9, a10, 0	# store byte 0
	addi	a4, a4, -1	# decrement n
	beqz    a4, .Lret       # if n is zero
	addi    a10, a10, 1	# advance dst pointer
	bbci.l	a10, 1, .Lfillaligned # if dst is now word-aligned
.Ldst2mod4:	# dst address is 2 mod 4
	s8i	a9, a10, 0	# store byte 0
	addi	a4, a4, -1	# decrement n
	beqz    a4, .Lret       # if n is zero
	s8i	a9, a10, 1	# store byte 1
	addi	a4, a4, -1	# decrement n
	beqz    a4, .Lret       # if n is zero
	addi    a10, a10, 2	# advance dst pointer
	j	.Lfillaligned

.Lret:
#if !XCHAL_HAVE_WINDOWED || __XTENSA_CALL0_ABI__
	l32i a10, a1, 8
	addi a1, a1, 16
	ret
#else
	retw
#endif


/*
 * dst is word-aligned, src is word-aligned
 * n is at least 1
 */
	.align	4
#if XCHAL_HAVE_LOOPS
#if XCHAL_HAVE_DENSITY
	# (2 mod 4) alignment for loop instruction
#else
	# (1 mod 4) alignment for loop instruction
	.byte	0
	.byte	0
#endif /* XCHAL_HAVE_DENSITY */
#endif /* XCHAL_HAVE_LOOPS */
.Laligned:
#if XCHAL_HAVE_LOOPS
#if XCHAL_HAVE_DENSITY
	_movi.n	a8, 0		# set up for the maximum loop count
#else
	_movi	a8, 0		# set up for the maximum loop count
#endif /* XCHAL_HAVE_DENSITY */
	loop	a8, .Lz3	# loop forever (almost anyway)
	blti	a4, 5, .Ldstunaligned  # n is near limit, do one at a time
	l32i	a8, a3, 0	# get word from src
	addi	a3, a3, 4	# advance src pointer
	bnone	a8, a11, .Lz0	# if byte 0 is zero
	bnone	a8, a5, .Lz1	# if byte 1 is zero
	bnone	a8, a6, .Lz2	# if byte 2 is zero
	s32i	a8, a10, 0	# store word to dst
	addi	a4, a4, -4	# decrement n
	addi	a10, a10, 4	# advance dst pointer
	bnone	a8, a7, .Lfill	# if byte 3 is zero
.Lz3:	

#else /* !XCHAL_HAVE_LOOPS */

.Lnextword:
	blti	a4, 5, .Ldstunaligned  # n is near limit, do one at a time
	l32i	a8, a3, 0	# get word from src
	addi	a3, a3, 4	# advance src pointer
	bnone	a8, a11, .Lz0	# if byte 0 is zero
	bnone	a8, a5, .Lz1	# if byte 1 is zero
	bnone	a8, a6, .Lz2	# if byte 2 is zero
	s32i	a8, a10, 0	# store word to dst
	addi	a4, a4, -4	# decrement n
	addi	a10, a10, 4	# advance dst pointer
	bany	a8, a7, .Lnextword	# no zeroes
#endif /* !XCHAL_HAVE_LOOPS */
	j	.Lfill

# byte 3 is zero
.Lz0:	# byte 0 is zero
#ifdef __XTENSA_EB__
	movi	a8, 0
#endif /* __XTENSA_EB__ */
	s8i	a8, a10, 0
	addi	a4, a4, -1	# decrement n
	addi	a10, a10, 1	# advance dst pointer
	j	.Lfill
.Lz1:	# byte 1 is zero
#ifdef __XTENSA_EB__
        extui   a8, a8, 16, 16
#endif /* __XTENSA_EB__ */
	s16i	a8, a10, 0
	addi	a4, a4, -2	# decrement n
	addi	a10, a10, 2	# advance dst pointer
	j	.Lfill
.Lz2:	# byte 2 is zero
#ifdef __XTENSA_EB__
        extui   a8, a8, 16, 16
#endif /* __XTENSA_EB__ */
	s16i	a8, a10, 0
	movi	a8, 0
	s8i	a8, a10, 2
	addi	a4, a4, -3	# decrement n
	addi	a10, a10, 3	# advance dst pointer
	j	.Lfill

	.align	4
#if XCHAL_HAVE_LOOPS
#if XCHAL_HAVE_DENSITY
	# (2 mod 4) alignment for loop instruction
#else
	# (1 mod 4) alignment for loop instruction
	.byte	0
	.byte	0
#endif /* XCHAL_HAVE_DENSITY */
#endif /* XCHAL_HAVE_LOOP */
.Ldstunaligned:
#if 1
/*
 * for now just use byte copy loop
 */
#if XCHAL_HAVE_LOOPS
#if XCHAL_HAVE_DENSITY
	_movi.n	a8, 0		# set up for the maximum loop count
#else
	_movi	a8, 0		# set up for the maximum loop count
#endif /* XCHAL_HAVE_DENSITY */
	loop	a8, .Lunalignedend # loop forever (almost anyway)
#endif /* XCHAL_HAVE_LOOPS */
.Lnextbyte:
	l8ui	a8, a3, 0
	addi	a3, a3, 1
	s8i	a8, a10, 0
	addi	a4, a4, -1
	beqz	a4, .Lret
	addi	a10, a10, 1
#if XCHAL_HAVE_LOOPS
	beqz	a8, .Lunalignedend
#else /* !XCHAL_HAVE_LOOPS */
	bnez	a8, .Lnextbyte
#endif /* !XCHAL_HAVE_LOOPS */
.Lunalignedend:
	j	.Lfill
#endif 
