/* errno is not a global variable, because that would make using it
   non-reentrant.  Instead, its address is returned by the function
   __errno.  */

#ifndef _SYS_ERRNO_H_
#ifdef __cplusplus
extern "C" {
#endif
#define _SYS_ERRNO_H_

#include <sys/reent.h>
/* change by Hareesh for T1050.5 XCC port of newlib */
#if 0 /* RA.2 */
#include <iss/simcall-errno.h>
#else /* T1050.5 */
#ifndef _SIMCALL_ERRNO_H
#define _SIMCALL_ERRNO_H

/* Define the error numbers (using the default newlib values) with prefixes
   so they can be used in ISS without conflicting with the host values.  */

#define	_SIMC_EPERM	1
#define	_SIMC_ENOENT	2
#define	_SIMC_ESRCH	3
#define	_SIMC_EINTR	4
#define	_SIMC_EIO	5
#define	_SIMC_ENXIO	6
#define	_SIMC_E2BIG	7
#define	_SIMC_ENOEXEC	8
#define	_SIMC_EBADF	9
#define	_SIMC_ECHILD	10
#define	_SIMC_EAGAIN	11
#define	_SIMC_ENOMEM	12
#define	_SIMC_EACCES	13
#define	_SIMC_EFAULT	14
#define	_SIMC_ENOTBLK	15
#define	_SIMC_EBUSY	16
#define	_SIMC_EEXIST	17
#define	_SIMC_EXDEV	18
#define	_SIMC_ENODEV	19
#define	_SIMC_ENOTDIR	20
#define	_SIMC_EISDIR	21
#define	_SIMC_EINVAL	22
#define	_SIMC_ENFILE	23
#define	_SIMC_EMFILE	24
#define	_SIMC_ENOTTY	25
#define	_SIMC_ETXTBSY	26
#define	_SIMC_EFBIG	27
#define	_SIMC_ENOSPC	28
#define	_SIMC_ESPIPE	29
#define	_SIMC_EROFS	30
#define	_SIMC_EMLINK	31
#define	_SIMC_EPIPE	32
#define	_SIMC_EDOM	33
#define	_SIMC_ERANGE	34
#define	_SIMC_ENOMSG	35
#define	_SIMC_EIDRM	36
#define	_SIMC_ECHRNG	37
#define	_SIMC_EL2NSYNC	38
#define	_SIMC_EL3HLT	39
#define	_SIMC_EL3RST	40
#define	_SIMC_ELNRNG	41
#define	_SIMC_EUNATCH	42
#define	_SIMC_ENOCSI	43
#define	_SIMC_EL2HLT	44
#define	_SIMC_EDEADLK	45
#define	_SIMC_ENOLCK	46
#define _SIMC_EBADE	50
#define _SIMC_EBADR	51
#define _SIMC_EXFULL	52
#define _SIMC_ENOANO	53
#define _SIMC_EBADRQC	54
#define _SIMC_EBADSLT	55
#define _SIMC_EDEADLOCK	56
#define _SIMC_EBFONT	57
#define _SIMC_ENOSTR	60
#define _SIMC_ENODATA	61
#define _SIMC_ETIME	62
#define _SIMC_ENOSR	63
#define _SIMC_ENONET	64
#define _SIMC_ENOPKG	65
#define _SIMC_EREMOTE	66
#define _SIMC_ENOLINK	67
#define _SIMC_EADV	68
#define _SIMC_ESRMNT	69
#define	_SIMC_ECOMM	70
#define _SIMC_EPROTO	71
#define	_SIMC_EMULTIHOP	74
#define	_SIMC_ELBIN	75
#define	_SIMC_EDOTDOT	76
#define _SIMC_EBADMSG	77
#define _SIMC_EFTYPE	79
#define _SIMC_ENOTUNIQ	80
#define _SIMC_EBADFD	81
#define _SIMC_EREMCHG	82
#define _SIMC_ELIBACC	83
#define _SIMC_ELIBBAD	84
#define _SIMC_ELIBSCN	85
#define _SIMC_ELIBMAX	86
#define _SIMC_ELIBEXEC	87
#define _SIMC_ENOSYS	88
#define	_SIMC_ENMFILE	89
#define _SIMC_ENOTEMPTY 90
#define _SIMC_ENAMETOOLONG 91
#define _SIMC_ELOOP 92
#define _SIMC_EOPNOTSUPP 95
#define _SIMC_EPFNOSUPPORT 96
#define _SIMC_ECONNRESET 104
#define _SIMC_ENOBUFS 105
#define _SIMC_EAFNOSUPPORT 106
#define _SIMC_EPROTOTYPE 107
#define _SIMC_ENOTSOCK 108
#define _SIMC_ENOPROTOOPT 109
#define _SIMC_ESHUTDOWN 110
#define _SIMC_ECONNREFUSED 111
#define _SIMC_EADDRINUSE 112
#define _SIMC_ECONNABORTED 113
#define _SIMC_ENETUNREACH 114
#define _SIMC_ENETDOWN 115
#define _SIMC_ETIMEDOUT 116
#define _SIMC_EHOSTDOWN 117
#define _SIMC_EHOSTUNREACH 118
#define _SIMC_EINPROGRESS 119
#define _SIMC_EALREADY 120
#define _SIMC_EDESTADDRREQ 121
#define _SIMC_EMSGSIZE 122
#define _SIMC_EPROTONOSUPPORT 123
#define _SIMC_ESOCKTNOSUPPORT 124
#define _SIMC_EADDRNOTAVAIL 125
#define _SIMC_ENETRESET 126
#define _SIMC_EISCONN 127
#define _SIMC_ENOTCONN 128
#define _SIMC_ETOOMANYREFS 129
#define	_SIMC_EPROCLIM 130
#define _SIMC_EUSERS 131
#define _SIMC_EDQUOT 132
#define _SIMC_ESTALE 133
#define _SIMC_ENOTSUP 134
#define _SIMC_ENOMEDIUM 135
#define	_SIMC_ENOSHARE 136
#define	_SIMC_ECASECLASH 137
#define _SIMC_EILSEQ 138
#define _SIMC_EOVERFLOW 139

#endif /* ! _SIMCALL_ERRNO_H */
#endif
/* end of change by Hareesh */

#ifndef _REENT_ONLY
#define errno (*__errno())
extern int *__errno _PARAMS ((void));
#endif

#define __errno_r(ptr) ((ptr)->_errno)

#define EPERM		_SIMC_EPERM
#define ENOENT		_SIMC_ENOENT
#define ESRCH		_SIMC_ESRCH
#define EINTR		_SIMC_EINTR
#define EIO		_SIMC_EIO
#define ENXIO		_SIMC_ENXIO
#define E2BIG		_SIMC_E2BIG
#define ENOEXEC		_SIMC_ENOEXEC
#define EBADF		_SIMC_EBADF
#define ECHILD		_SIMC_ECHILD
#define EAGAIN		_SIMC_EAGAIN
#define ENOMEM		_SIMC_ENOMEM
#define EACCES		_SIMC_EACCES
#define EFAULT		_SIMC_EFAULT
#define ENOTBLK		_SIMC_ENOTBLK
#define EBUSY		_SIMC_EBUSY
#define EEXIST		_SIMC_EEXIST
#define EXDEV		_SIMC_EXDEV
#define ENODEV		_SIMC_ENODEV
#define ENOTDIR		_SIMC_ENOTDIR
#define EISDIR		_SIMC_EISDIR
#define EINVAL		_SIMC_EINVAL
#define ENFILE		_SIMC_ENFILE
#define EMFILE		_SIMC_EMFILE
#define ENOTTY		_SIMC_ENOTTY
#define ETXTBSY		_SIMC_ETXTBSY
#define EFBIG		_SIMC_EFBIG
#define ENOSPC		_SIMC_ENOSPC
#define ESPIPE		_SIMC_ESPIPE
#define EROFS		_SIMC_EROFS
#define EMLINK		_SIMC_EMLINK
#define EPIPE		_SIMC_EPIPE
#define EDOM		_SIMC_EDOM
#define ERANGE		_SIMC_ERANGE
#define ENOMSG		_SIMC_ENOMSG
#define EIDRM		_SIMC_EIDRM
#define ECHRNG		_SIMC_ECHRNG
#define EL2NSYNC	_SIMC_EL2NSYNC
#define EL3HLT		_SIMC_EL3HLT
#define EL3RST		_SIMC_EL3RST
#define ELNRNG		_SIMC_ELNRNG
#define EUNATCH		_SIMC_EUNATCH
#define ENOCSI		_SIMC_ENOCSI
#define EL2HLT		_SIMC_EL2HLT
#define EDEADLK		_SIMC_EDEADLK
#define ENOLCK		_SIMC_ENOLCK
#define EBADE		_SIMC_EBADE
#define EBADR		_SIMC_EBADR
#define EXFULL		_SIMC_EXFULL
#define ENOANO		_SIMC_ENOANO
#define EBADRQC		_SIMC_EBADRQC
#define EBADSLT		_SIMC_EBADSLT
#define EDEADLOCK	_SIMC_EDEADLOCK
#define EBFONT		_SIMC_EBFONT
#define ENOSTR		_SIMC_ENOSTR
#define ENODATA		_SIMC_ENODATA
#define ETIME		_SIMC_ETIME
#define ENOSR		_SIMC_ENOSR
#define ENONET		_SIMC_ENONET
#define ENOPKG		_SIMC_ENOPKG
#define EREMOTE		_SIMC_EREMOTE
#define ENOLINK		_SIMC_ENOLINK
#define EADV		_SIMC_EADV
#define ESRMNT		_SIMC_ESRMNT
#define ECOMM		_SIMC_ECOMM
#define EPROTO		_SIMC_EPROTO
#define EMULTIHOP	_SIMC_EMULTIHOP
#define ELBIN		_SIMC_ELBIN
#define EDOTDOT		_SIMC_EDOTDOT
#define EBADMSG		_SIMC_EBADMSG
#define EFTYPE		_SIMC_EFTYPE
#define ENOTUNIQ	_SIMC_ENOTUNIQ
#define EBADFD		_SIMC_EBADFD
#define EREMCHG		_SIMC_EREMCHG
#define ELIBACC		_SIMC_ELIBACC
#define ELIBBAD		_SIMC_ELIBBAD
#define ELIBSCN		_SIMC_ELIBSCN
#define ELIBMAX		_SIMC_ELIBMAX
#define ELIBEXEC	_SIMC_ELIBEXEC
#define ENOSYS		_SIMC_ENOSYS
#define ENMFILE		_SIMC_ENMFILE
#define ENOTEMPTY	_SIMC_ENOTEMPTY
#define ENAMETOOLONG	_SIMC_ENAMETOOLONG
#define ELOOP		_SIMC_ELOOP
#define EOPNOTSUPP	_SIMC_EOPNOTSUPP
#define EPFNOSUPPORT	_SIMC_EPFNOSUPPORT
#define ECONNRESET	_SIMC_ECONNRESET
#define ENOBUFS		_SIMC_ENOBUFS
#define EAFNOSUPPORT	_SIMC_EAFNOSUPPORT
#define EPROTOTYPE	_SIMC_EPROTOTYPE
#define ENOTSOCK	_SIMC_ENOTSOCK
#define ENOPROTOOPT	_SIMC_ENOPROTOOPT
#define ESHUTDOWN	_SIMC_ESHUTDOWN
#define ECONNREFUSED	_SIMC_ECONNREFUSED
#define EADDRINUSE	_SIMC_EADDRINUSE
#define ECONNABORTED	_SIMC_ECONNABORTED
#define ENETUNREACH	_SIMC_ENETUNREACH
#define ENETDOWN	_SIMC_ENETDOWN
#define ETIMEDOUT	_SIMC_ETIMEDOUT
#define EHOSTDOWN	_SIMC_EHOSTDOWN
#define EHOSTUNREACH	_SIMC_EHOSTUNREACH
#define EINPROGRESS	_SIMC_EINPROGRESS
#define EALREADY	_SIMC_EALREADY
#define EDESTADDRREQ	_SIMC_EDESTADDRREQ
#define EMSGSIZE	_SIMC_EMSGSIZE
#define EPROTONOSUPPORT	_SIMC_EPROTONOSUPPORT
#define ESOCKTNOSUPPORT	_SIMC_ESOCKTNOSUPPORT
#define EADDRNOTAVAIL	_SIMC_EADDRNOTAVAIL
#define ENETRESET	_SIMC_ENETRESET
#define EISCONN		_SIMC_EISCONN
#define ENOTCONN	_SIMC_ENOTCONN
#define ETOOMANYREFS	_SIMC_ETOOMANYREFS
#define EPROCLIM	_SIMC_EPROCLIM
#define EUSERS		_SIMC_EUSERS
#define EDQUOT		_SIMC_EDQUOT
#define ESTALE		_SIMC_ESTALE
#define ENOTSUP		_SIMC_ENOTSUP
#define ENOMEDIUM	_SIMC_ENOMEDIUM
#define ENOSHARE	_SIMC_ENOSHARE
#define ECASECLASH	_SIMC_ECASECLASH
#define EILSEQ		_SIMC_EILSEQ
#define EOVERFLOW	_SIMC_EOVERFLOW

#define EWOULDBLOCK	EAGAIN

/* DS2 */
#define ENOERR 0
#define EBADREQ 140   
#define EBADARG 141
#define ECRC    142
#define EINTERNAL 143
#define E_OK ENOERR
#define EUKDEV 144
#define EDRNRDY 145
/* END DS2 */

#define __ELASTERROR 2000	/* Users can add values starting here */

#ifdef __cplusplus
}
#endif
#endif /* _SYS_ERRNO_H */
