
/*
 * Copyright 2007 Design of Systems on Silicon (DS2) All rights reserved.
 */

/**
 * @addtogroup sha2
 * @{
**/

/**
 * @file sha2_pub.c
 * @brief This code implements the SHA2 message-digest algorithm.
 *
 * @internal
 *
 * @author Ramon Rodriguez
 * @date 29/03/2007
 * 
**/

#include "types.h"
#ifndef TOOLS
#  include "LCAssert_pub.h"
#else
#  include <assert.h>
#  define assertpoint(E, ID) (assert((E)))
#endif
#include "sha2_pub.h"
#include "sha2_protocol_pub.h"

void SHA256Hash(INT8U *hash, const INT8U *data, INT32U length)
{
  // INT8U hash[32]; // 256 bits
  sha2_context    ctx;

  assertpoint(length <= (INT32U)MAX_INT32S, 1);

  sha2_starts(&ctx);
  sha2_update(&ctx, (unsigned char *)data, (int)length);
  sha2_finish(&ctx, (unsigned char *)hash);
}

INT8U SHA2ComponentIsPresent(void)
{
  return 1;
}

/**
 * @}
**/
