
/*
 * Copyright 2007 Design of Systems on Silicon (DS2) All rights reserved.
 */

/**
 * @addtogroup sha2
 * @{
**/

/**
 * @file sha2_pub.h
 * @brief SHA2 message-digest algorithm header file.
 *
 * @internal
 *
 * @author Ramon Rodriguez
 * @date 29/03/2007
 *  
**/

#ifndef SHA2_PUB_H
#  define SHA2_PUB_H

/**
 * @brief SHA-256 buffer hash
 *
 * @param hash   SHA-256 checksum result
 * @param data   buffer holding the data
 * @param length length of the input data
 **/
void            SHA256Hash(INT8U *hash, const INT8U *data, INT32U length);

/**
 * @brief Find out whether the component is Present or not
 *
 * @return 1 -> if is present 0->if not  
 **/
INT8U           SHA2ComponentIsPresent(void);

#endif /* SHA2_PUB_H */

/**
 * @}
**/
